import { PromiseOrValue } from "./interfaces";
import { PromiseCallback, PromiseErrback, PromiseProgback } from "./promise/Promise";

/**
  * Transparently applies callbacks to values and/or promises.
  */
export declare function when<T>(value: PromiseOrValue<T>): PromiseLike<T>;
export declare function when<T, U1, U2>(value: PromiseOrValue<T>, callback?: PromiseCallback<T, U1>, errback?: PromiseErrback<U2>, progress?: PromiseProgback): PromiseOrValue<U1 | U2>;